#ifndef __XBEEPACKETS_H
#define __XBEEPACKETS_H

#include "global_vars.h"

//define API_MODE_2 if you want to use escape characters.  Otherwise it will assume XBee API mode 1.
#define API_MODE_2

#define TIMEOUT_COUNT 5000
#define WAIT_TIMEOUT 	timeout=0;\
	while (timeout<TIMEOUT_COUNT && !DataRdyUART2() ){\
		timeout++;\
	}\
	if (timeout>=TIMEOUT_COUNT){\
		return -1;\
	}



//This union is used to split a 32-bit Float into 4 bytes	
union packetFloat{
	float dataFloat;
	unsigned char dataChar[DATATYPE_BYTELENGTH];
};


//The most recent received packet is stored into this struct
struct IN_PACKET
{
	unsigned int length;
	unsigned char API_ID;
	unsigned int source;
	unsigned char RSSI;
	unsigned char options;
	union packetFloat data[DATA_ARRAY_LENGTH+ADDITIONAL_NUMS];                //peng, 8/6
	unsigned char checksum;
};

//extern union packetFloat;
extern volatile struct IN_PACKET InPacket;





//Public Functions:
//unsigned char getMY_ID( void );
void assemblePacket( float rawData[], unsigned int destination );  //assembles and sends packets 
int readPacket( void );
void flushBufferUART2(void);

//Private Functions:

//read a byte from buffer, apply escapes if needed.
unsigned char readByte(void);	

//set up packet headers in outPacket raw packet array
void initPacket(unsigned char outPacket[], unsigned int *indexPtr);	

//load a new byte into outPacket at the index
void loadByte(unsigned char outPacket[], unsigned char byte, unsigned int *indexPtr);

//sends assembled packet to UART2
void sendPacket(unsigned char outPacket[], unsigned int Index);


#endif

