// send_packet function. Pulled out of main by Sam Bobb
// August 2009

#include "send_packet.h"
#include "global_vars.h"
//#include "e_led.h"
//#include "wheel_speed_coordinator.h"
#include "e_motors_swarm.h"
//#include "dsPIC_XBeePackets.h"
#include "e_acc.h"
#include "e_epuck_ports.h"


extern volatile float x_i[NUM_DATA_SETS];	//x, current_estimate/decision variables
extern volatile float w_i[NUM_DATA_SETS];	//w, internal estimator state




void send_packet(void){
	float packet[DATA_ARRAY_LENGTH+ADDITIONAL_NUMS]={0};	//make array to hold data to send to radio
	
	unsigned int i=0;	//counter variable
	unsigned int j=0;	//another counter variable
	
	float robotX = 0;  //Robot's position/orientation
	float robotY = 0;
	float robotTheta = 0;

	
	for (i=0,j=0;i<DATA_ARRAY_LENGTH;){
		packet[i]=x_i[j];	//packet is structured x_1, w_1, x_2, w_2, etc.
		i++;
		packet[i]=w_i[j];
		i++;
		j++;
	}	
	//add on additional numbers to packet.  These numbers are used for data logging, not consensus estimation.
	e_get_configuration(&robotX, &robotY, &robotTheta);
	packet[i]=robotX;
	i++;
	packet[i]=robotY;
	i++;
	packet[i]=robotTheta;
	i++;
	packet[i]=u_x_ideal;
	i++;
	packet[i]=u_y_ideal;	
	
	/*
	blue_value=e_get_acc_filtered(0, 136);  
	green_value=e_get_acc_filtered(1, 136);
	red_value=e_get_acc_filtered(2, 136);
	*/
	
	i++;
	packet[i]=e_get_acc_filtered(2, 136); // red
	i++;
	packet[i]=e_get_acc_filtered(1, 136); // green
	i++;
	packet[i]=e_get_acc_filtered(0, 136); // blue
	
	notRTS=1;	//assert flow control line to stop XBee from sending
	assemblePacket(packet, 0xFFFF);	//assemble and send packet
	notRTS=0;	//deassert flow control; Xbee can send again
	
}

